package jmg.pfc.puzlefotoapp.model;


import jmg.pfc.puzlefotoapp.definitions.Definitions;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;


// Classe per crear i actualitzar la base de dades
public class PuzleFotoSQLiteOpenHelper extends SQLiteOpenHelper {
	
	// Nom de la base de dades
	private static final String DATABASE_NAME = "DBPuzleFotoApp.db";
	
	// Aquest nombre sempre ha d'anar incrementant (en cas contrari, error)
	private static final int DATABASE_VERSION = 1;
	
	//Instruccion SQL de creaci de taula.      
    private static final String SQL_CREATE_TABLE_SAVEDGAME = "CREATE TABLE SavedGame (idSavedGame INTEGER PRIMARY KEY AUTOINCREMENT,"
    						+ " idPuzleEducational INTEGER, dimensions INTEGER, piecePosition TEXT,"
    						+ " pathFile TEXT, puzleType INTEGER, educationalTitle TEXT, educationalMessage TEXT,"
    						+ " puzledate TIMESTAMP NOT NULL DEFAULT current_timestamp, aRL INTEGER, aRR INTEGER, aRT INTEGER, aRB INTEGER)";    
	
    	  
    
    // Creaci de la base de dades.
	public PuzleFotoSQLiteOpenHelper(Context context, String name,CursorFactory factory, int version) {    
		super(context, DATABASE_NAME, factory, DATABASE_VERSION);
    }

	// Creaci de la taula
    @Override
    public void onCreate(SQLiteDatabase db) {
    	Log.i(Definitions.PuzleTagLOG,"--->Es crea la taula:" +SQL_CREATE_TABLE_SAVEDGAME);
        db.execSQL(SQL_CREATE_TABLE_SAVEDGAME);        
    }
 
    // Funci que s'executa si canvia el nombre de versio.
    @Override
    public void onUpgrade(SQLiteDatabase db, int lastVersion, int newVersion) {
    	if (lastVersion!=newVersion)
    	{    	
        	db.execSQL("DROP TABLE IF EXISTS SavedGame");
    		onCreate(db);
    	}
    }

}
