package jmg.pfc.puzlefotoapp.tools;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

import jmg.pfc.puzlefotoapp.definitions.Definitions;
import android.content.Context;
import android.os.Environment;
import android.util.Log;
import android.widget.Toast;
 

// Classe per copiar en un arxiu el contingut del Log.
public class LogTool {

	private static String filePath = "/PuzleFotoAppDir/salidaLog.txt";
	Context context;
	public LogTool (Context context) {
		this.context = context;
	}
	
	// Genera una cadena de text amb el contingut del log
	private String getLogCatDetails() {
		String logData = "";
		try
		{
			Process process = Runtime.getRuntime().exec(new String[]{"logcat", "-d"});
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream()));
			StringBuilder log = new StringBuilder();
			String line = "";
			while ((line = bufferedReader.readLine()) != null)
			{
				log.append(line);
			}
		
			logData = log.toString();
		
		}
		catch (Exception e)
		{
			if(e!=null)
				e.printStackTrace();
		}
		
		return logData;
	}
	
	// Copia el contigut del log en un arxiu.
	public void logToFile() {
		
		clearLogFile();
		try
		{	
			  File path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES);
			  Toast toast1 = Toast.makeText(context, path.toString()+filePath, Toast.LENGTH_LONG);
			  toast1.show();
			  
			  OutputStream os = new FileOutputStream(path+filePath, true);
			  os.write(getLogCatDetails().getBytes());
			  os.close();			  
		}
		catch (Exception ex)
		{
			Toast toast1 = Toast.makeText(context, ex.toString(), Toast.LENGTH_LONG);
			  toast1.show();			
		    Log.i(Definitions.PuzleTagLOG, "Error al escribir fichero a memoria interna");
		    
		}
	}
	
	// Esborra l'arxiu de log copiat
	private void clearLogFile() {
		
		File path = new File (Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES).toString(), filePath);		
		path.delete();
		
	}
	
	
}
