package jmg.pfc.puzlefotoapp.view;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.Definitions;
import jmg.pfc.puzlefotoapp.view.acceptimagetools.RectangleImageView;
import android.content.Intent;
import android.graphics.Rect;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.Toast;



//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class AcceptImage_Activity extends ActionBarActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_accept_image_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.accept_image_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// L'acci la realitzar el fragment.		
			return false;
		}
		return super.onOptionsItemSelected(item);
	}
		
	
	
	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {
		
		Rect rectFinal = null;
		int originalDimensionsX;
		int originalDimensionsY;
		int viewedDimensionsX;
		int viewedDimensionsY;		
		RectangleImageView view;	
		LinearLayout.LayoutParams params;
		DisplayMetrics metrics;
		Intent act;
		
		public PlaceholderFragment() {
		}

		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    // Permet gestionar el menu des del fragment
		    setHasOptionsMenu(true);
		}
			
		// Gesti del menu des del fragment
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {
		    // Es crida a una nova activitat
		    case R.id.menu_about:
		    	act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		
		
		
		
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(R.layout.fragment_accept_image_, container, false);			
			
			return rootView;
		}
		
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);

            // Llegim la informaci generada en les activitats anteriors
		    PlayerSelectedValues selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");		 			
            
		    // Es referencia el component que mostra la imatge amb el requadre
            view = (RectangleImageView)getActivity().findViewById(R.id.rectangleImage);

            // Llegim les dimensions de la pantalla del dispositiu
            metrics = new DisplayMetrics();	
    		getActivity().getWindowManager().getDefaultDisplay().getMetrics(metrics);            

            // Establim les dimensions que farem servir en la pantalla
    		view.setMetrics(metrics.widthPixels, metrics.heightPixels-(int)(metrics.heightPixels*0.3));
    		// Carreguem la imatge
            view.setImage(selection.getPathFile());
            // Obtenim les dimensions originals de la imatge
            originalDimensionsX=view.getOriginalDimensionsX();
            originalDimensionsY=view.getOriginalDimensionsY();
            // Obtenim les dimensions de la imatge escalada
            viewedDimensionsX = view.getViewedDimensionsX();
            viewedDimensionsY = view.getViewedDimensionsY();
            // Colocaci dels botons de la pantalla segons les dimensions de la imatge
            params = new LinearLayout.LayoutParams(viewedDimensionsX, viewedDimensionsY);
            view.setLayoutParams(params);            
            
            // Es llegeix les coordenades del requadre a sobre de la imatge
            if (null != view) {
               view.setOnUpCallback(new RectangleImageView.OnUpCallback() {
                   @Override
                   public void onRectFinished(final Rect rect) {
                   	rectFinal = rect;
                   }
               });
            }            
            
            // Es rebutja la imatge
	        ImageButton bDiscard = (ImageButton) getActivity().findViewById(R.id.buttonDiscard);
	        bDiscard.setOnClickListener(new View.OnClickListener(){
	                @Override
	                public void onClick(View v) { 
	                	finishActivity();
	                }
	            });	        
            
	        // S'accepta la imatge
	        ImageButton bAccept = (ImageButton) getActivity().findViewById(R.id.buttonAccept);
            bAccept.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) {
                	if (rectFinal==null) {
                		// Indiquem que s'ha de moure el requadre abans d'acceptar
        				Toast toast1 = Toast.makeText(getActivity().getApplicationContext(),getResources().getString(R.string.text_move_square_before_accept_image), Toast.LENGTH_LONG);
        				toast1.show();
                	}
                	loadImage();
                }
            });         	        
        }
		
		// Aquesta funci calcula el tros d'imatge seleccionat per l'usuari tenint en compte que
		// la imatge original es diferent de la imatge mostrada en pantalla. s a dir, s'ha de 
		// escalar la selecci realitzada, ja que la imatge que es 'retalla' es la original, no 
		// la que es mostra en pantalla.
		private void loadImage() {

		    PlayerSelectedValues selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");		 			
           	if (rectFinal!=null) {
           		Log.i(Definitions.PuzleTagLOG,"Rectangle capturat:"+rectFinal.toString());
           		Rect newR = new Rect();
           		float relationX=(float)((float)rectFinal.left/(float)viewedDimensionsX);                   		
           		float tempX= (originalDimensionsX*relationX);                   		
           		newR.left=(int)tempX;
           		relationX=(float)((float)rectFinal.right/(float)viewedDimensionsX);                   		
        		tempX= (originalDimensionsX*relationX);                		
        		newR.right=(int)tempX;
           		float relationY=(float)((float)rectFinal.top/(float)viewedDimensionsY);                   		
        		float tempY= (originalDimensionsY*relationY);
        		newR.top=(int)tempY;
           		relationY=(float)((float)rectFinal.bottom/(float)viewedDimensionsY);                   		
        		tempY= (originalDimensionsY*relationY);
        		newR.bottom=(int)tempY;

           		// Es guarda la selecci realitzada
           		selection.setAcceptedRectLeft(newR.left);
           		selection.setAcceptedRectRight(newR.right);
           		selection.setAcceptedRectTop(newR.top);
           		selection.setAcceptedRectBottom(newR.bottom);
           		
           		Log.i(Definitions.PuzleTagLOG,"Rectangle processat adaptat:"+newR.toString());           		
           		
     		    // Pasem els valors a la segent activitat
             	act = new Intent(getActivity().getApplicationContext(), PuzleConfiguration_Activity.class);
            	act.putExtra("PARCELABLE", selection);
            	startActivity(act); 
            	finishActivity();
           		
           	}
		}
	
		// Finalitzem l'activitat
		private void finishActivity() {
			if (view!=null)
				view=null;
			if (params!=null)
				params=null;
			if (metrics!=null)
				metrics=null;
			if (act!=null)
				act=null;

        	if (getActivity()!=null)
        		getActivity().finish();			
		}
	}

}
