package jmg.pfc.puzlefotoapp.view;


import java.util.ArrayList;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.view.educationaltools.AdapterItemEducationalPuzle;
import jmg.pfc.puzlefotoapp.view.educationaltools.ItemEducationalPuzle;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class EducationalPuzle_Activity extends ActionBarActivity {


	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_educational_puzle_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.educational_puzle_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// L'acci la realitzar el fragment.		
			return false;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		ArrayList<ItemEducationalPuzle> array = new ArrayList<ItemEducationalPuzle>();
		ListView puzleList;
		ItemEducationalPuzle itemEducationalPuzle;
		AdapterItemEducationalPuzle adapter;
		Intent act;		
		PlayerSelectedValues selection;		
		
		// Llista dels identificadors dels puzles educatius
    	int imagesId[]={R.drawable.anade_real_r_c, R.drawable.apples_r_c, R.drawable.blackberries_r_c, R.drawable.casa_batllo_r_c,
    			R.drawable.colleseum_r_c, R.drawable.dark_pink_rose_r_c, R.drawable.easter_eggs_r_c, R.drawable.grapes_r_c, 
    			R.drawable.great_spotted_woodpecker_r_c, R.drawable.land_snail_r_c, R.drawable.peacock_r_c,	R.drawable.pineapple_r_c, 
    			R.drawable.purple_daisy_r_c, R.drawable.raspberries_r_c, R.drawable.sea_snail_shell_r_c, R.drawable.strawberries_r_c, 
    			R.drawable.tomatoes_r_c, R.drawable.white_swan_r_c, R.drawable.white_water_lily_r_c, 
    			R.drawable.wild_horse_r_c};
    	
    	// Llista dels titols dels puzles educatius
    	int title[]={R.string.title1,R.string.title2,R.string.title3, R.string.title4, R.string.title5, R.string.title6,
    			R.string.title7, R.string.title8, R.string.title9, R.string.title10, R.string.title11, R.string.title12,
    			R.string.title13, R.string.title14, R.string.title15, R.string.title16, R.string.title17, R.string.title18,
    			R.string.title19, R.string.title20};
    	
    	// Llista de missatges que es mostren per pantalla quan es resol un puzle educatiu
    	int message[]={R.string.message1,R.string.message2,R.string.message3, R.string.message4, R.string.message5, R.string.message6,
    			R.string.message7, R.string.message8, R.string.message9, R.string.message10, R.string.message11, R.string.message12,
    			R.string.message13, R.string.message14, R.string.message15, R.string.message16, R.string.message17, R.string.message18,
    			R.string.message19, R.string.message20};
		
		
		
		
		
		public PlaceholderFragment() {
		}


		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}
				
		// Gesti del menu des del fragment		
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_about:
		    	// Es crida a una nova activitat
		    	act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		
		
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(
					R.layout.fragment_educational_puzle_, container, false);
			return rootView;
		}
		
        @Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);
            loadImages();
            
        }
        
        // Funci que carrega una llista lliscant amb els puzles educatius
        private void loadImages() {
        	        	
	        puzleList = (ListView) getActivity().findViewById(R.id.educationalPuzleListView);        
	        int nPuzles = imagesId.length;
	 
	        int i;
	 
	        // Carreguem l'array amb els puzles.
	        for (i=0;i<nPuzles;i++) {
		        itemEducationalPuzle = new ItemEducationalPuzle(getResources().getDrawable(imagesId[i]), getResources().getString(title[i]), getResources().getString(message[i]), imagesId[i]);
		        array.add(itemEducationalPuzle);
	        	
	        }
	       
	        // Es crea l'adaptador que indica com manegar els elements de la llista
	        adapter = new AdapterItemEducationalPuzle(getActivity(), array);
	 
	        // L'adaptador es fa servir en la llista
	        puzleList.setAdapter(adapter);
                    
	        // Selecci d'un element de la llista
	        puzleList.setOnItemClickListener(new OnItemClickListener() {
	            @Override
	            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	               
	                int item = array.get(position).getId();
        			// Obtenim la informaci generada per les activitats anteriors
        		    selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");
        		    // Afegim la informaci generada en aquesta activitat
        		    selection.setIdPuzleEducational(item);
        		    selection.setEducationalTitle(getResources().getString(title[position]));
        		    selection.setEducationalMessage(getResources().getString(message[position]));        		    
        		    // Cridem a la Activity de configuraci del puzle
                	act = new Intent(getActivity().getApplicationContext(), PuzleConfiguration_Activity.class);
                	act.putExtra("PARCELABLE", selection);
                	startActivity(act);  
                	finishActivity();
	            }
	        });	            

        	
        }
    
        // Es finalitza l'activitat
        private void finishActivity() {
   		
    	if (array != null)
   			array = null;
   		
   		if (puzleList != null)
   			puzleList = null;
   		
   		if (itemEducationalPuzle != null)
   			itemEducationalPuzle=null;
   		
   		if (adapter != null)
   			adapter = null;
   		
   		if (act != null)
   			act = null;
   		
   		if (selection != null)
   			selection = null;
   		
    	if (getActivity()!=null)
    		getActivity().finish();	   		
       }
        
        
	}
}
