package jmg.pfc.puzlefotoapp.view;


import jmg.pfc.puzlefotoapp.R;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class GalleryPuzle_Activity extends ActionBarActivity {
	
	private static int ACTIVITY_GALLERY=1;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gallery_puzle_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.gallery_puzle_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// Aquesta part s'implementa des del fragment		
			return false;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		public PlaceholderFragment() {
		}

		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}

		// La gesti del menu es fa des del fragment
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_about:
		    	// Es crida a una nova activitat
		    	Intent act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		
		
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(R.layout.fragment_gallery_puzle_,
					container, false);
			return rootView;
		}
		
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);            
            // Es carrega la galleria d'imatges
            openGallery();

        }
		
		// Crida a l'aplicaci de la galeria d'imatges
        private void openGallery() {
            Intent galleryIntent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
            // Indiquem que esperem que retorni un resultat
            startActivityForResult(galleryIntent, ACTIVITY_GALLERY);
        }	

        
        // Obt el resultat de la crida a la galeria d'imatges 
        public void onActivityResult(int requestCode, int resultCode, Intent data) {
        
        	super.onActivityResult(requestCode, resultCode, data);
            if (resultCode == RESULT_OK) {
                if (requestCode == ACTIVITY_GALLERY) {	 
                    String imagePath = getImagePath(data);
         		    // Obtenim els valors de l'activitat anterior	                        
         		    PlayerSelectedValues selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");
         		    // Modifiquem els valors seleccionats pel jugador
         		    selection.setPathFile(imagePath);
         		    // Pasem els valors a la segent activitat
                 	Intent act = new Intent(getActivity().getApplicationContext(), AcceptImage_Activity.class);
                	act.putExtra("PARCELABLE", selection);
                	startActivity(act);
                	if (getActivity()!=null)
                		getActivity().finish();                	
                } 
            } else {
            	if (getActivity()!=null)
            		getActivity().finish();
            }
            
            
        }
        
        // Agafem el path de la imatge seleccionada
        private String getImagePath(Intent data) {
            Uri selectedImage = data.getData();
            String[] filePath = { MediaStore.Images.Media.DATA };
            Cursor cursor = getActivity().getApplicationContext().getContentResolver().query(selectedImage, filePath, null, null, null);
            cursor.moveToFirst();
            String imagePath = cursor.getString(cursor.getColumnIndex(filePath[0]));
        	return imagePath;
        }
        
        
        
	}

	
	
}
