package jmg.pfc.puzlefotoapp.view;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.Definitions;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class PhotographyPuzle_Activity extends ActionBarActivity {
	
	private static int ACTIVITY_CAMERA=1;
	private static String DIR_PATH="PuzleFotoAppDir";
	private static Uri fotoFile;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_photography_puzle_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.photography_puzle_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// Aquesta tasca la realitza el fragment		
			return false;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		public PlaceholderFragment() {
		}


		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}

		// Gesti del men des del fragment
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_about:
		    	// Es crida a una nova activitat
		    	Intent act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		

		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(
					R.layout.fragment_photography_puzle_, container, false);
			return rootView;
		}
		
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);
            // Cmera de fotos.
            openCamera();
        }
		
		// Es crida a l'aplicaci de la cmera de fotos
		// La foto que es realitza es guarda en la ubicaci que indiguem (fotoFile)
		// D'aquesta manera podem saber on es troba per poder llegir-la
		private void openCamera() {
			fotoFile = Uri.fromFile(getNewPhotoFileName());
		    Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
		    intent.putExtra(MediaStore.EXTRA_OUTPUT, fotoFile);	
		    // S'indica que es vol obtenir un resultat
		    startActivityForResult(intent, ACTIVITY_CAMERA);			
		}
		
		//Obt el resultat de la crida a la cmera 
        public void onActivityResult(int requestCode, int resultCode, Intent data) {
        
        	super.onActivityResult(requestCode, resultCode, data);
            if (resultCode == RESULT_OK) {
                if (requestCode == ACTIVITY_CAMERA) {	 
                	
                    String imagePath = fotoFile.getPath();               	
                	
         		    // Obtenim els valors de l'activitat anterior	                        
         		    PlayerSelectedValues selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");
         		    // Anotem el path de la fotografia
         		    selection.setPathFile(imagePath);

         		    // Pasem els valors a la segent activitat
                 	Intent act = new Intent(getActivity().getApplicationContext(), AcceptImage_Activity.class);
                	act.putExtra("PARCELABLE", selection);
                	startActivity(act);
                	if (getActivity()!=null)
                		getActivity().finish();
                	
                } 
            } else {
            	if (getActivity()!=null)
            		getActivity().finish();
            }
        }      
        
        // Generaci del nom de l'arxiu que tindr la fotografia
        private File getNewPhotoFileName() {
        	
        	File dir = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES),DIR_PATH);
         
            // Es crea el directori en cas que no existeixi
            if (!dir.exists()) {
                if (!dir.mkdirs()) {
                    Log.i(Definitions.PuzleTagLOG, " PhotographyActivity:No se puede crear el directorio!!: "+ DIR_PATH);
                    return null;
                }
            }        	
        	
        	// El nom esta format per la data i la hora actual
        	String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                    Locale.getDefault()).format(new Date());
            File file;
            
			file = new File(dir.getPath() + File.separator
			        + "IMG_" + timeStamp + ".jpg");
            
            return file;
        }

        
        
	}

}
