package jmg.pfc.puzlefotoapp.view;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.PuzleType;
import jmg.pfc.puzlefotoapp.model.PuzleFotoSQLite;
import jmg.pfc.puzlefotoapp.view.playpuzletools.EducationalDialog;
import jmg.pfc.puzlefotoapp.view.playpuzletools.PaintCanvasPieces;
import jmg.pfc.puzlefotoapp.view.savegametools.OptionDialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v7.app.ActionBarActivity;
import android.util.DisplayMetrics;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Toast;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class PlayPuzle_Activity extends ActionBarActivity {

	int fragmentId;
	PlaceholderFragment fragment;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_play_puzle_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.play_puzle_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_save) {
			// Ho fa el fragment
			return false;
		}

		if (id == R.id.menu_help) {
			// Ho fa el fragment
			return false;
		}
					
		if (id == R.id.menu_sound) {
			// Ho fa el fragment			
			return false;			
		}
		
		if (id == R.id.menu_about) {
			// Ho fa el fragment			
			return false;
		}
				
		return super.onOptionsItemSelected(item);
	}
	
	
		@Override
	  public void onAttachFragment(Fragment fragment) {
	    super.onAttachFragment(fragment);
	    if (fragment instanceof PlaceholderFragment) {
	    	PlaceholderFragment f = ((PlaceholderFragment) fragment);
	    	fragmentId = f.getId();
	    }
	  }
	
	
	// Al polsar el bot de retrocs es mostra un dialeg oferint
	// la possibilitat de desar la partida abans de sortir
	public void onBackPressed() {
		
		
		FragmentManager fm = getSupportFragmentManager();
		fragment = (PlaceholderFragment)fm.findFragmentById(fragmentId);
		
		FragmentManager fragmentManager = getSupportFragmentManager();
		OptionDialog dialog = new OptionDialog();
		dialog.setInfo(getResources().getString(R.string.text_optional_dialog_title), getResources().getString(R.string.text_optional_dialog_message));
				
		
		if (null != dialog && !fragment.view.getResolved() && !fragment.view.getSaved()) {
			
				dialog.show(fragmentManager, "tagAlerta");						
	        	dialog.setOnSelectCallback(new OptionDialog.OnSelectCallback() {
				
                   @Override
                   public void onSelection(int response) {
                   		if (response==OptionDialog.ACCEPT) {    	                   			
                            fragment.onSave(PlaceholderFragment.SAVE_GAME_AND_EXIT);
                   		} else if (response==OptionDialog.DISCARD) {
                   			
                   		}
                     
                   }
               });
        } else {        	
			fragment.finishActivity();
		}
	}
	


	
	

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		static final int SAVE_GAME = 1;
		static final int SAVE_GAME_AND_EXIT = 2;		
		
		PlayerSelectedValues selection;
		PaintCanvasPieces view;
		Intent act;	
		DisplayMetrics metrics;	
		ImageView previewPuzle;
		
		
		
		public PlaceholderFragment() {
		}

		

		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}
		
		// La gesti del men es fa des del frament
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_save:
		    	// Es salva la partida
		    	onSave(SAVE_GAME);
		        return true;
		    case R.id.menu_help:
		    	// Activa o desactiva l'ajuda numerica
		    	onHelp();
		        return true;    
		    case R.id.menu_sound:
		    	// Activa o desactiva el so de l'aplicacio
		    	changeMute();
		        return true;		        
		    case R.id.menu_about:
		    	// Es crida a una nova activitat
		    	act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		        
		        
		    default:
		        break;
		    }

		    return false;
		}		
		
		
		
		
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(R.layout.fragment_play_puzle_, container, false);
			return rootView;
		}
		
		
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);           
            loadPanel();
		}

		@Override
        public void onPause() {
            super.onPause();
		}
		
		@Override
        public void onResume() {            
            super.onResume();
		}

		// Es carrega el puzle en pantalla
		private void loadPanel() {
			
			// S'instancia el component que dibuixa el puzle
			view = (PaintCanvasPieces)getActivity().findViewById(R.id.canvasPuzle);
			metrics = new DisplayMetrics();
			// S'agafen les opcions generades a activitats anteriors
			selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");
			// Es calculen les dimensions del dispositiu per adaptar el que es mostra en pantalla
			getActivity().getWindowManager().getDefaultDisplay().getMetrics(metrics);
            view.setPlayerSelectedValues(selection, metrics.widthPixels, metrics.heightPixels-(int)(metrics.heightPixels*0.3));
            int xy = Math.min(metrics.widthPixels, metrics.heightPixels);
            LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(xy,xy);
            view.setLayoutParams(params);
            // Es carrega la imatge
            view.loadImage();
            // Es retallen les peces del puzle
            view.cutInPieces();
            // Es barrejen les peces
      	  	view.mixPieces();          
      	  	
            // Es mira si s'ha resolt el puzle
            if (null != view) {
            	view.setOnResolved(new PaintCanvasPieces.OnResolved(){
            	    @Override
                    public void onPuzleResolved(int value) {
                    	PuzleType pt = selection.getPuzleType();
                    	// Si s'ha resolt un puzle educatiu es mostra el missatge associat al puzle
                    	if (pt.getType()==PuzleType.EDUCATIONAL_TYPE || pt.getType()==PuzleType.SAVEDGAME_EDUCATIONAL ) {
							FragmentManager fragmentManager = getActivity().getSupportFragmentManager();
							EducationalDialog dialog = new EducationalDialog();
							dialog.setInfo(selection.getEducationalTitle(), selection.getEducationalMessage());
							dialog.show(fragmentManager, "tagAlerta");             
                    	}
                    	
                    	// Si s'ha resolt una partida desada, aquesta s'esborra de la base de dades.
                    	if (pt.getType()==PuzleType.SAVEDGAME_EDUCATIONAL || pt.getType()==PuzleType.SAVEDGAME_GALLERY || pt.getType()==PuzleType.SAVEDGAME_PHOTOGRAPHY) {
                    		PuzleFotoSQLite bbdd = new PuzleFotoSQLite(getActivity().getApplicationContext());              	
                    		bbdd.delSavedGame(selection.getIdSavedGame());
                    	}
                    }
                });	
            }

            // Es mostra la imatge petita d'ajuda per resoldre el puzle.
            previewPuzle = (ImageView)getActivity().findViewById(R.id.previewPuzle);
            previewPuzle.setAdjustViewBounds(true);
            previewPuzle.setPadding(0, 0, 0, 0);
            int size = Math.max(metrics.heightPixels, metrics.widthPixels);
            previewPuzle.setMaxHeight(size/5);
            previewPuzle.setMaxWidth(size/5);                        
            previewPuzle.setImageBitmap(view.getPreviewPuzle()); 	  

            
            // Bot per desar partida
            ImageButton bSave = (ImageButton) getActivity().findViewById(R.id.buttonSave);
	        bSave.setOnClickListener(new View.OnClickListener(){
	                @Override
	                public void onClick(View v) { 
	                   	onSave(SAVE_GAME);
	                }
	            });	        
            
	        // Bot per mostra l'ajuda numrica
	        ImageButton bHelp = (ImageButton) getActivity().findViewById(R.id.buttonHelp);
            bHelp.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) { 
                	 onHelp();
                }
            });     
                        
		}
		
		// Es guarda la partida
		private void onSave(int requestCode) {
			
			int i;
			String piecesPosition = "";
	
			if (!view.getSaved() && !view.getResolved())  {
				
				// Obtenim les posicions actuals de les peces del puzle i les separem amb guions (-)				
				for (i=0;i<selection.getDimensions();i++) {
					piecesPosition += view.getPiecePosition(i);
					if (i<selection.getDimensions()-1)
						piecesPosition+="-";
				}
				// Guardem les posicions de les peces
				selection.setPiecesPosition(piecesPosition);
			
				// Pasem els valors a la segent activitat
				act = new Intent(getActivity().getApplicationContext(), SaveGame_Activity.class);
				act.putExtra("PARCELABLE", selection);
				startActivityForResult(act, requestCode);
			} else if (!view.getResolved() && requestCode!=SAVE_GAME_AND_EXIT ) {
				// Es mostra el text que indica que s'ha de moure abans de desar.
				Toast toast1 = Toast.makeText(getActivity().getApplicationContext(),getResources().getString(R.string.text_move_before_saving_puzle), Toast.LENGTH_LONG);
				toast1.show();
			}
        	
		}
		
		 
		// Un cop que s'ha desat la partida, es continua jugant o es finalitza
		// l'activitat (tot depen des d'on s'hagi cridat onSave())
        public void onActivityResult(int requestCode, int resultCode, Intent data) {
        
        	super.onActivityResult(requestCode, resultCode, data);
        	int id;
            if (resultCode == RESULT_OK && requestCode == SAVE_GAME) {               	
            	id = data.getExtras().getInt("idSavedG");                	
				view.setSaved(true);       
				selection.setIdSavedGame(id);
                
            } else if (resultCode == RESULT_OK && requestCode == SAVE_GAME_AND_EXIT) {               	
            	id = data.getExtras().getInt("idSavedG");                	
				view.setSaved(true);       
				selection.setIdSavedGame(id);
				finishActivity();				
            } else {
            	// TODO -> Exception o Toast!
            	finishActivity();            	
            }
        }      
		
        
        // Activacio/desactivacio de l'ajuda numerica
        private void onHelp() {
        	view.onHelp();
        }
        
        // Activacio/desactivacio dels sons
        private void changeMute() {
        	view.changeMute();
        }
        
		// Es finalitza l'activitat
        private void finishActivity() {
			if (view!=null)
				view=null;
			if (selection!=null)
				selection=null;
			if (metrics!=null)
				metrics=null;
			if (act!=null)
				act=null;
			
			if (previewPuzle!=null)
				previewPuzle=null;
			

        	if (getActivity()!=null)
        		getActivity().finish();			
		}
		
	}
}
