package jmg.pfc.puzlefotoapp.view;

import java.util.ArrayList;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.view.puzleconfigurationtools.AdapterItemPuzleConfiguration;
import jmg.pfc.puzlefotoapp.view.puzleconfigurationtools.ItemPuzleConfiguration;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;


//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class PuzleConfiguration_Activity extends ActionBarActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_puzle_configuration_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.puzle_configuration_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// Ho fa el fragment			
			return false;
		}
		return super.onOptionsItemSelected(item);
	}


	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {
		

		ArrayList<ItemPuzleConfiguration> array = new ArrayList<ItemPuzleConfiguration>();
		AdapterItemPuzleConfiguration adapter;		
        private ListView listConfigurations;	
        PlayerSelectedValues selection; 
        ItemPuzleConfiguration itemPuzleConfiguration;
        Intent act;
        
        // Elements que contenen la llista lliscant (Dimensions del puzle)
    	int imagesId[]={R.drawable.puzle_configurations_22, R.drawable.puzle_configurations_33, R.drawable.puzle_configurations_44};
    	int message[]={R.string.configuration_2x2, R.string.configuration_3x3, R.string.configuration_4x4 };
    	int values[]={4, 9, 16};

		public PlaceholderFragment() {
		}

		// Per poder afegir menus
		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}
				
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_about:
		    	act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		
				
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(
					R.layout.fragment_puzle_configuration_, container, false);
			return rootView;
		}
		
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);
            
            // Dimensions del puzle
            setDimensions();
		}		
		
		// Es crea una llista lliscant amb les dimensions del puzle
		private void setDimensions() {

			int i;
            listConfigurations = (ListView)getActivity().findViewById(R.id.listConfigurations);
	        
            // S'omple un array amb les opcions disponibles
            for (i=0;i<imagesId.length;i++) {
    		    itemPuzleConfiguration = new ItemPuzleConfiguration(getResources().getDrawable(imagesId[i]),getResources().getString(message[i]), i, values[i]);
    		    array.add(itemPuzleConfiguration);
            }
		    
		    // Es crea un adaptador que indica com tractar cada element de la llista
	        adapter = new AdapterItemPuzleConfiguration(getActivity(), array);
	 
	        // S'aplica l'adaptador a la llista lliscant
	        listConfigurations.setAdapter(adapter);
                    
	        // Selecci d'un element de la llista
	        listConfigurations.setOnItemClickListener(new OnItemClickListener() {
	            @Override
	            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	               
	                int dimensions = array.get(position).getDimensions();
        			// S'obetnen els valors seleccionats en activitats anteriors
        		    selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");
        		    // Es guarda el valor seleccionat
        		    selection.setDimensions(dimensions);
    				// Pasem els valors a la segent activitat
    				act = new Intent(getActivity().getApplicationContext(), PlayPuzle_Activity.class);
    				act.putExtra("PARCELABLE", selection);
    				startActivity(act);            
                	finishActivity();
	            }
	        });	            
            
		}
		
		
		// Finalitzaci de l'activitat
        private void finishActivity() {
			if (listConfigurations!=null)
				listConfigurations=null;
			if (selection!=null)
				selection=null;
			if (act!=null)
				act=null;
			if (itemPuzleConfiguration!=null)
				itemPuzleConfiguration=null;
			if (array!=null)
				array=null;
        	if (getActivity()!=null)
        		getActivity().finish();			
		}		
		
		
	}
}
