package jmg.pfc.puzlefotoapp.view;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.PuzleType;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class PuzleSelection_Activity extends ActionBarActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_puzle_selection_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.puzle_selection_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// Ho fa el fragment			
			return false;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		public PlaceholderFragment() {
		}

		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}
			
		// Gesti del menu des del fragment
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_about:
		    	// Es crida una nova activitat
		    	Intent act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		
				
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(
					R.layout.fragment_puzle_selection_, container, false);
			return rootView;
		}
		
		
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);
            // Carreguem els botons de selecci de tipus de puzle.
            loadButtonsMenu();
        }			
		
		// Es mostren els botons associats a cada tipus de puzle.
		// Per cada bot es carreguen els valors per defecte
		// que s'aniran modificant en les diferents activitats 
		// de l'aplicaci.
		private void loadButtonsMenu()
		{
            ImageButton bEducatiu = (ImageButton)getActivity().findViewById(R.id.puzleEducational);      
            bEducatiu.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) { 
                	
                	PlayerSelectedValues selection = new PlayerSelectedValues();
        			selection.setPuzleType(new PuzleType(PuzleType.EDUCATIONAL_TYPE));                	
                	selection.setPathFile("");
        			selection.setIdPuzleEducational(1);
        			selection.setAcceptedRectLeft(0);        			
        			selection.setAcceptedRectRight(0);        			
        			selection.setAcceptedRectTop(0);        			
        			selection.setAcceptedRectBottom(0);        			
                	Intent act = new Intent(getActivity().getApplicationContext(), EducationalPuzle_Activity.class);
                	act.putExtra("PARCELABLE", selection);	                	
                	startActivity(act);                  	
                }
            });            
            
            ImageButton bFoto = (ImageButton)getActivity().findViewById(R.id.puzlePhotography);      
            bFoto.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) {
                	PlayerSelectedValues selection = new PlayerSelectedValues();
        			selection.setPuzleType(new PuzleType(PuzleType.PHOTOGRAPHY_TYPE));
        			selection.setPathFile("");	        		
        			selection.setAcceptedRectLeft(0);        			
        			selection.setAcceptedRectRight(0);        			
        			selection.setAcceptedRectTop(0);        			
        			selection.setAcceptedRectBottom(0);        			
                	Intent act = new Intent(getActivity().getApplicationContext(), PhotographyPuzle_Activity.class);
                	act.putExtra("PARCELABLE", selection);	                	
                	startActivity(act);                  	
                }
            });            
            
            ImageButton bGaleria = (ImageButton)getActivity().findViewById(R.id.puzleGallery);      
            bGaleria.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) {
                	PlayerSelectedValues selection = new PlayerSelectedValues();
        			selection.setPuzleType(new PuzleType(PuzleType.GALLERY_TYPE));
        			selection.setPathFile("");
        			selection.setAcceptedRectLeft(0);        			
        			selection.setAcceptedRectRight(0);        			
        			selection.setAcceptedRectTop(0);        			
        			selection.setAcceptedRectBottom(0);        			        			
        			selection.setIdPuzleEducational(1);
                	Intent act = new Intent(getActivity().getApplicationContext(), GalleryPuzle_Activity.class);
                	act.putExtra("PARCELABLE", selection);	                	
                	startActivity(act);     	
                }
            });            

            ImageButton bSavedGame = (ImageButton)getActivity().findViewById(R.id.puzleSavedGame);      
            bSavedGame.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) {            
                	PlayerSelectedValues selection = new PlayerSelectedValues();
                	// Posem un tipus null perque encara no sabem quin tipus s'escull
                	selection.setPuzleType(new PuzleType(PuzleType.NULL_TYPE));                	
                	Intent act = new Intent(getActivity().getApplicationContext(), SelectSavedGame_Activity.class);
                	act.putExtra("PARCELABLE", selection);	                	
                	startActivity(act);                  	
                }
            });  			
		}		
		
	}

}
