package jmg.pfc.puzlefotoapp.view;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.PuzleType;
import jmg.pfc.puzlefotoapp.model.PuzleFotoSQLite;
import jmg.pfc.puzlefotoapp.view.savegametools.SavedGameDialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v7.app.ActionBarActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class SaveGame_Activity extends ActionBarActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_save_game_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		public PlaceholderFragment() {
		}
		
		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		}
				

		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(R.layout.fragment_save_game_, container, false);
			return rootView;
		}
		
		
	
		@Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);
            int idSavedGame;
			
            // Es llegeixen els valors generats a les activitats anteriors
            PlayerSelectedValues selection = getActivity().getIntent().getParcelableExtra("PARCELABLE");
            
            // Canvi del tipus de Puzle a puzle guardat (segons el tipus anterior)
            if (selection.getPuzleType().getType()<=PuzleType.GALLERY_TYPE)
            	selection.setPuzleType(new PuzleType(PuzleType.GALLERY_TYPE+selection.getPuzleType().getType()));
            	
            // Es salva la partida a la base de dades
			PuzleFotoSQLite bbdd = new PuzleFotoSQLite(getActivity().getApplicationContext());              	
        	idSavedGame=bbdd.setSavedGame(selection);
        	
        	// Es retorna l'identificador generat per la base de dades (associat a l'element guardat)
        	Intent intent = new Intent();
        	intent.putExtra("idSavedG", idSavedGame);
            getActivity().setResult(RESULT_OK,intent);       
        	
            // Es mostra un dialeg per pantalla indicant que s'ha desat la partida
			FragmentManager fragmentManager = getActivity().getSupportFragmentManager();
			SavedGameDialog dialog = new SavedGameDialog();
			dialog.setInfo(getResources().getString(R.string.text_dialog_save_saved), getResources().getString(R.string.text_dialog_save_game_saved));
			dialog.show(fragmentManager, "tagAlerta");
		}
			
	}

}
