package jmg.pfc.puzlefotoapp.view;

import java.util.ArrayList;
import java.util.Vector;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.Definitions;
import jmg.pfc.puzlefotoapp.definitions.PuzleType;
import jmg.pfc.puzlefotoapp.model.PuzleFotoSQLite;
import jmg.pfc.puzlefotoapp.view.savegametools.AdapterItemSavedGame;
import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.TextView;

//Aquesta classe ha sigut creada amb l'ajuda del 'wizard' d'eclipse
//Noms es comenten les funcions creades/modificades especificament pel projecte PuzleFotoApp
public class SelectSavedGame_Activity extends ActionBarActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_select_saved_game_);

		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	
// Per depuraci.		
//		LogTool l = new LogTool(this.getApplicationContext());
//		l.logToFile();
	}
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.select_saved_game_, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.menu_about) {
			// Ho fa el fragment			
			return false;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		ArrayList<PlayerSelectedValues> array = new ArrayList<PlayerSelectedValues>();
		ListView puzleList;	
		PuzleFotoSQLite bbdd;
		Vector<PlayerSelectedValues> vectorSavedGames;	
		AdapterItemSavedGame adapter;
		PlayerSelectedValues item;
		Intent act;		
		
		
		public PlaceholderFragment() {
		}


		public void onCreate(Bundle savedInstanceState) {
		    super.onCreate(savedInstanceState);
		    setHasOptionsMenu(true);
		}

		// Gesti del menu des del fragment
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {

		    case R.id.menu_about:
		    	// Es crida a una nova activitat
		    	act = new Intent(getActivity().getApplicationContext(), About_Activity.class);
            	startActivity(act); 
		        return true;
		    default:
		        break;
		    }

		    return false;
		}		
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(
					R.layout.fragment_select_saved_game_, container, false);
			return rootView;
		}
		
		
        @Override
        public void onActivityCreated(Bundle state) {
            super.onActivityCreated(state);
            loadImages();
            
        }

        // Es carrega una llista lliscant amb les partides desades
        private void loadImages() {
        	int i;
        	
        	// Es recuperen totes les partides desades a la base de dades 
            PlayerSelectedValues temp1;
	        puzleList = (ListView) getActivity().findViewById(R.id.savedGameListView);
	        bbdd = new PuzleFotoSQLite(getActivity().getApplicationContext());              	
	        vectorSavedGames = bbdd.getAllSavedGames();
	        
	        if (vectorSavedGames.size()>0) {

	        	// S'introdueixen tots els valors en l'array
		        for (i=0;i<vectorSavedGames.size();i++) {
		        	temp1 = vectorSavedGames.get(i);
		        	// Es comprova que la referencia a la imatge del puzle es correcte
		        	if (validImagePuzleResource(temp1)) 
		        		array.add(temp1);
		        	else {
		        		// En cas d'inconsistencia s'esborra l'element de la base de dades.
		        		Log.i(Definitions.PuzleTagLOG, "ES BORRA:"+temp1.getIdSavedGame() +" per que no existeix el resource id:"+temp1.getIdPuzleEducational());
		        		bbdd.delSavedGame(temp1.getIdSavedGame());
		        	}
		        }
		        
		        // Es crea un adaptador per indicar a la llista com es gestionen els seus elements
		        adapter = new AdapterItemSavedGame(getActivity(), array);
		 
		        // S'aplica l'adaptador a la llista
		        puzleList.setAdapter(adapter);
		       
	        } else {
	        	// Si no hi ha partidas desades, s'indica per pantalla.
	        	TextView t = (TextView)getActivity().findViewById(R.id.textSelecciona);
	        	t.setText(R.string.text_no_selected_saved_game);
	        }
	        
                    
	        // Es selecciona un element de la llista
	        puzleList.setOnItemClickListener(new OnItemClickListener() {
	            @Override
	            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	            
	            	item = array.get(position);
	                	                   
        		    // Cridem a la Activity de configuraci del puzle indicant l'item seleccionat
                	act = new Intent(getActivity().getApplicationContext(), PlayPuzle_Activity.class);
                	act.putExtra("PARCELABLE", item);
                	startActivity(act);

                	finishActivity();
                		
	            }
	        });	            
        }
        
        
        // Es comproba que la partida desada te una imatge correcte.
        private boolean validImagePuzleResource(PlayerSelectedValues p) {
        	boolean result=true;

        	try {
        		if (p.getPuzleType().getType()==PuzleType.SAVEDGAME_EDUCATIONAL)
        		{       			
                	String temp = getResources().getDrawable(p.getIdPuzleEducational()).getClass().toString();
        			if (!temp.contains("BitmapDrawable")) {       				
        				Log.i(Definitions.PuzleTagLOG, "No es de tipus Bitmap!!");
        				result=false;        				
        			} else {
        				result=true;
        			}
        		}
        	} catch (Resources.NotFoundException e) {
        		Log.i(Definitions.PuzleTagLOG, "No s'ha trobat el resource id");        		
        		result=false;        		
        	}
        	return result;
        }
        
        
        // Es finalitza l'activitat
        private void finishActivity() {
			
        	if (array!=null)
				array=null;
			
			if (puzleList!=null)
				puzleList=null;
			
			if (bbdd!=null)
				bbdd=null;
			
			if (vectorSavedGames!=null)
				vectorSavedGames=null;

			if (adapter!=null)
				adapter=null;

			if (item!=null)
				item=null;
			
			
			if (act!=null)
				act=null;
			

        	if (getActivity()!=null)
        		getActivity().finish();			
		}	
		
	}
	
	
}
