package jmg.pfc.puzlefotoapp.view.educationaltools;

import java.util.ArrayList;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.tools.LoadImages;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.TextView;

// Classe que actua com a adaptador per indicar com gestionar els elements d'una llista lliscant
public class AdapterItemEducationalPuzle extends BaseAdapter{
	
    protected Activity activity;
    protected ArrayList<ItemEducationalPuzle> items;	

	public AdapterItemEducationalPuzle(Activity activity, ArrayList<ItemEducationalPuzle> items) {
        this.activity = activity;
        this.items = items;
	}
 
    @Override
    public int getCount() {
        return items.size();
    }
 
    @Override
    public Object getItem(int arg0) {
        return items.get(arg0);
    }
 
    @Override 
    public long getItemId(int position) {
        return items.get(position).getId();
    }
 
    // Funci que indica com obtenir un element. Aix ho fa servir la ListView per carregar els seus elements
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
 
    	View v = convertView;
	 
    	if(convertView == null){
    		LayoutInflater inf = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    		v = inf.inflate(R.layout.item_educational_puzle, null);
    	}
 
		ItemEducationalPuzle iEP = items.get(position);

		ImageView photo = (ImageView) v.findViewById(R.id.puzleImage);

		// Omplim la imatge de l'element
		photo.setImageBitmap(LoadImages.decodeSampledBitmapFromResource(activity.getResources(), iEP.getId(), 190, 190, 2));		
		photo.setScaleType(ScaleType.FIT_CENTER);
        photo.setPadding(10, 10, 10, 10);
        photo.setAdjustViewBounds(true);
        photo.setContentDescription(iEP.getTitle());
        photo.setMaxHeight(190);
        photo.setMaxWidth(190);
		
		
        // Omplim el nom del element
		TextView puzleName = (TextView) v.findViewById(R.id.puzleText);
		puzleName.setText(iEP.getTitle());		
		puzleName.setMaxHeight(100);
		puzleName.setTypeface(Typeface.DEFAULT, Typeface.BOLD);
		puzleName.setGravity(Gravity.CENTER);
		puzleName.setTextColor(Color.BLACK);
		
        return v;
    }
}
