package jmg.pfc.puzlefotoapp.view.puzleconfigurationtools;

import java.util.ArrayList;

import jmg.pfc.puzlefotoapp.R;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.TextView;

//Classe que actua com a adaptador per indicar com gestionar els elements d'una llista lliscant
public class AdapterItemPuzleConfiguration extends BaseAdapter {
	
    protected Activity activity;
    protected ArrayList<ItemPuzleConfiguration> items;	

	public AdapterItemPuzleConfiguration(Activity activity, ArrayList<ItemPuzleConfiguration> items) {
        this.activity = activity;
        this.items = items;
	}
 
    @Override
    public int getCount() {
        return items.size();
    }
 
    @Override
    public Object getItem(int arg0) {
        return items.get(arg0);
    }
 
    @Override 
    public long getItemId(int position) {
        return items.get(position).getId();
    }
 

    // Funci que indica com obtenir un element. Aix ho fa servir la ListView per carregar els seus elements    
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
 
    	View v = convertView;
	 
    	if(convertView == null){
    		LayoutInflater inf = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    		v = inf.inflate(R.layout.item_puzle_configuration, null);
    	}
 
      
    	ItemPuzleConfiguration iEP = items.get(position);
		// Omplim la imatge de l'element	
		ImageView photo = (ImageView) v.findViewById(R.id.configurationImage);
		photo.setImageDrawable(iEP.getConfigurationImage());
		photo.setScaleType(ScaleType.FIT_CENTER);
        photo.setPadding(10, 10, 10, 10);
        photo.setAdjustViewBounds(true);
        photo.setMaxHeight(190);
        photo.setMaxWidth(190);

        // Omplim el text
		TextView puzleName = (TextView) v.findViewById(R.id.configurationText);
		puzleName.setText(iEP.getText());		
		puzleName.setMaxHeight(100);
		puzleName.setTypeface(Typeface.DEFAULT, Typeface.BOLD);
		puzleName.setGravity(Gravity.CENTER);
		puzleName.setTextColor(Color.BLACK);
		

        return v;
    }

	

}
