package jmg.pfc.puzlefotoapp.view.savegametools;


import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;

import jmg.pfc.puzlefotoapp.R;
import jmg.pfc.puzlefotoapp.definitions.PuzleType;
import jmg.pfc.puzlefotoapp.tools.LoadImages;
import jmg.pfc.puzlefotoapp.view.PlayerSelectedValues;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.TextView;

//Classe que actua com a adaptador per indicar com gestionar els elements d'una llista lliscant
public class AdapterItemSavedGame extends BaseAdapter{
	
    protected Activity activity;
    protected ArrayList<PlayerSelectedValues> items;	

	public AdapterItemSavedGame(Activity activity, ArrayList<PlayerSelectedValues> items) {
        this.activity = activity;
        this.items = items;
	}
 
    @Override
    public int getCount() {
        return items.size();
    }
 
    @Override
    public Object getItem(int arg0) {
        return items.get(arg0);
    }
 
    @Override 
    public long getItemId(int position) {
        return items.get(position).getIdSavedGame();
    }
 

    // Funci que indica com obtenir un element. Aixo ho fa servir la ListView per carregar els seus elements    
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
 
    	ViewHolderItem viewHolder;

    	View v = convertView;
	 
    	// Per tal d'optimitzar es guarda el contingut d'un element en el tag
    	// La propera vegada no cal crear-lo, noms obtenir-lo del tag.
    	if(convertView == null){
    		LayoutInflater inf = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    		v = inf.inflate(R.layout.item_savedgame_puzle, null);
    		viewHolder = new ViewHolderItem();
    		viewHolder.imageViewItem = (ImageView) v.findViewById(R.id.savedGameImage);
    		viewHolder.textViewItem = (TextView) v.findViewById(R.id.savedGameText);    		
    		v.setTag(viewHolder);
    	} else {
    		viewHolder = (ViewHolderItem) convertView.getTag();
    	}
 
 
    	PlayerSelectedValues iSG = items.get(position);		
    	// Omplim la imatge
		if (iSG.getPuzleType().getType()==PuzleType.EDUCATIONAL_TYPE || iSG.getPuzleType().getType()==PuzleType.SAVEDGAME_EDUCATIONAL)
		{
			viewHolder.imageViewItem.setImageBitmap(LoadImages.decodeSampledBitmapFromResource(activity.getResources(), iSG.getIdPuzleEducational(), 190, 190, 2));
		} else {
			viewHolder.imageViewItem.setImageBitmap(LoadImages.decodeSampledBitmapFromPathFile(iSG.getPathFile(), 190, 190,4));			
		}
		viewHolder.imageViewItem.setScaleType(ScaleType.FIT_CENTER);
		viewHolder.imageViewItem.setPadding(10, 10, 10, 10);
		viewHolder.imageViewItem.setAdjustViewBounds(true);
		viewHolder.imageViewItem.setContentDescription(Long.toString(iSG.getDate()));
		viewHolder.imageViewItem.setMaxHeight(190);
		viewHolder.imageViewItem.setMaxWidth(190);

		
		//Omplim la data
		viewHolder.textViewItem.setText(getDate(iSG.getDate(),"dd/MM/yyyy"));
		viewHolder.textViewItem.setMaxHeight(100);
		viewHolder.textViewItem.setTypeface(Typeface.DEFAULT, Typeface.BOLD);
		viewHolder.textViewItem.setGravity(Gravity.CENTER);
		viewHolder.textViewItem.setTextColor(Color.BLACK);
		
        return v;
    }
    
    // Classes contingudes en un element de la llista
    static class ViewHolderItem {
    	ImageView imageViewItem;
    	TextView textViewItem;
    }
    
    
     
    // Funci per generar una cadena amb la data a partir d'un timestamp
    private static String getDate(long seconds, String dateFormat)
    {   	
    	DateFormat formatter = new SimpleDateFormat(dateFormat);	 
        Calendar calendar = Calendar.getInstance();
        calendar.setTimeInMillis(seconds*1000);
        return formatter.format(calendar.getTime());
    }
}
