package jmg.pfc.puzlefotoapp.view.savegametools;


import jmg.pfc.puzlefotoapp.R;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

// Dialeg per decidir si es desa una partida abans de sortir.
// Es genera un event per indicar l'opci escollida.
public class OptionDialog extends DialogFragment {
		
	public static int DISCARD = 0;
	public static int ACCEPT = 1;
	
	private String title;
	private String message;
	
	// Es genera un event indicant la opci seleccionada
	private OnSelectCallback mCallback = null;

    public interface OnSelectCallback {
        void onSelection(int response);
    }	
	
	// Variable que genera l'event
    public void setOnSelectCallback(OnSelectCallback callback) {
        mCallback = callback;
    }    
    
	
	
	public void setInfo(String title, String message) {
		this.title = title;
		this.message = message;
	}
	
	
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
 
        AlertDialog.Builder builder =
                new AlertDialog.Builder(getActivity());
 
	        builder.setMessage(message)
            .setTitle(title)
            .setPositiveButton(getResources().getString(R.string.text_ok), new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int id) {
                    dialog.cancel();
                    // Es genera un event indicant que s'ha acceptat
                    mCallback.onSelection(OptionDialog.ACCEPT);
                    if (getActivity()!=null)
                 	   getActivity().finish();
                }
            })
            .setNegativeButton(getResources().getString(R.string.text_cancel), new DialogInterface.OnClickListener() {
            	public void onClick(DialogInterface dialog, int id) {
            		dialog.cancel();
                    // Es genera un event indicant que s'ha rebutjat            		
                    mCallback.onSelection(OptionDialog.DISCARD);            		
                    if (getActivity()!=null)
                    	getActivity().finish();
                        
                   }
               });        	
        return builder.create();
    }
}

	
	
	
	
	
